#define N_IMPLEMENTS nWaterNode
//------------------------------------------------------------------------------
//  (C) 2002	tom@3d-inferno.com
//------------------------------------------------------------------------------
#include "water/nwaternode.h"
#include "kernel/nfileserver.h"

static void n_setsize(void* slf, nCmd* cmd);
static void n_getsize(void* slf, nCmd* cmd);
static void n_setreadonly(void* slf, nCmd* cmd);
static void n_getreadonly(void* slf, nCmd* cmd);
static void n_setcastshadow(void* slf, nCmd* cmd);
static void n_getcastshadow(void* slf, nCmd* cmd);
static void n_setamplitude(void* slf, nCmd* cmd);
static void n_getamplitude(void* slf, nCmd* cmd);
static void n_getheight(void* slf, nCmd* cmd);
static void n_gettype(void* slf, nCmd* cmd);
static void n_settype(void* slf, nCmd* cmd);

//------------------------------------------------------------------------------
/**
    @scriptclass
    nwater
    
    @superclass
    nanimnode

    @classinfo
    A detailed description of what the class does (written for script programmers!) 
*/
void
n_initcmds(nClass* clazz)
{
    clazz->BeginCmds();
//	clazz->AddCmd("v_setsize_ii", 'SSZE', n_setsize);
	clazz->AddCmd("ii_getsize_v", 'GSZE', n_getsize);
	clazz->AddCmd("v_setreadonly_b", 'SRDO', n_setreadonly);
	clazz->AddCmd("b_getreadonly_v", 'GRDO', n_getreadonly);
	clazz->AddCmd("v_setcastshadow_b", 'SCSD', n_setcastshadow);
	clazz->AddCmd("b_getcastshadow_v", 'GCSD', n_getcastshadow);
	clazz->AddCmd("f_getheight_ff", 'GHGT', n_getheight);
	clazz->AddCmd("i_gettype_v", 'GTYP', n_gettype);
	clazz->AddCmd("b_settype_i", 'STYP', n_settype);
    clazz->EndCmds();
}

//------------------------------------------------------------------------------
/**
    @cmd
    xxx

    @input
    v

    @output
    v

    @info
    detailed description (for script programmers! no C++ babble)
*/


//------------------------------------------------------------------------------
/**
    @cmd
    xxx

    @input
    v

    @output
    v

    @info
    detailed description (for script programmers! no C++ babble)
*/
static void n_setsize(void* slf, nCmd* cmd)
{
    nWaterNode* self = (nWaterNode*) slf;
    self->SetSize(cmd->In()->GetI());
}

static void n_getsize(void* slf, nCmd* cmd)
{
    nWaterNode* self = (nWaterNode*) slf;
    cmd->Out()->SetI(self->GetSize());
//	cmd->Out()->SetI(self->GetYSize());
}


//------------------------------------------------------------------------------
/**
    @cmd
    xxx

    @input
    v

    @output
    v

    @info
    detailed description (for script programmers! no C++ babble)
*/
static void n_setreadonly(void* slf, nCmd* cmd)
{
    nWaterNode* self = (nWaterNode*) slf;
    self->SetReadOnly(cmd->In()->GetB());
}

static void n_getreadonly(void* slf, nCmd* cmd)
{
    nWaterNode* self = (nWaterNode*) slf;
    cmd->Out()->SetB(self->GetReadOnly());
}

static void n_setcastshadow(void* slf, nCmd* cmd)
{
    nWaterNode* self = (nWaterNode*) slf;
    self->SetCastShadow(cmd->In()->GetB());
}

static void n_getcastshadow(void* slf, nCmd* cmd)
{
    nWaterNode* self = (nWaterNode*) slf;
    cmd->Out()->SetB(self->GetCastShadow());
}

static void n_getheight(void* slf, nCmd* cmd)
{
    nWaterNode* self = (nWaterNode*) slf;
    cmd->Out()->SetF(self->GetHeight(cmd->In()->GetF(), cmd->In()->GetF()));
}

static void n_settype(void * slf, nCmd* cmd)
{
	nWaterNode* self = (nWaterNode*) slf;
	cmd->Out()->SetB(self->SetType(cmd->In()->GetI()));
}

static void n_gettype(void * slf, nCmd* cmd)
{
	nWaterNode* self = (nWaterNode*) slf;
	cmd->Out()->SetI(self->GetType());
}



//------------------------------------------------------------------------------
/**
    @param  fileServer  writes the nCmd object contents out to a file.
    @return             success or failure
*/
bool
nWaterNode::SaveCmds(nFileServer* fs)
{
    if (nVisNode::SaveCmds(fs))
    {
		nCmd *cmd;
		
		//--- settype ---
		if (this->GetType()>=0)
		{
			cmd = fs->GetCmd(this, 'GTYP');
			cmd->In()->SetI(this->GetType());
			fs->PutCmd(cmd);
		}	

        return true;
    }
    return false;
}