#define N_IMPLEMENTS nWaterNode
//------------------------------------------------------------------------------
//  (C) 2002	tom@3d-inferno.com
//------------------------------------------------------------------------------
#include "water/nwaterserver.h"
#include "water/nwaternode.h"
#include "gfx/nvertexbuffer.h"
#include "gfx/ngfxserver.h"
#include "gfx/nscenegraph2.h"
#include "gfx/nindexbuffer.h"
#include "gfx/nchannelcontext.h"
#include "math/nmath.h"
#include "kernel/ntypes.h"

//nNebulaScriptClass(nWaterNode, "nvisnode");

//------------------------------------------------------------------------------
/**
    Attach mesh node to scene.

    @param  sceneGraph      pointer to scene graph object
    @return                 true if success
*/
bool 
nWaterNode::Attach(nSceneGraph2 *sceneGraph)
{
    n_assert(sceneGraph);

    if (nVisNode::Attach(sceneGraph)) 
	{
		if(this->ref_Server.isvalid())
			sceneGraph->AttachVisualNode(this);
		return true;
    } 
    return false;
}


void nWaterNode::AttachChannels(nChannelSet* chnSet)
{
    n_assert(chnSet);
    this->localChannelIndex = chnSet->AddChannel(this->refChannel.get(), "time");
    nVisNode::AttachChannels(chnSet);
}
//------------------------------------------------------------------------------
/**
    Update myself and render to dynamic mesh, or set as current vertex
    buffer in scene graph if I'm read only

    @param  sceneGraph      pointer to scene graph object

    - 14-Feb-02   ghoust		created
	- 08-Apr-02	ghoust		cleaned
*/

static float tpassed = 0.0f;

void nWaterNode::Compute(nSceneGraph2* sceneGraph)
{
	bool render = true;
    n_assert(sceneGraph);
    nVisNode::Compute(sceneGraph);
	
//n_printf("update server\n");	
	if(this->ref_Server.isvalid())
	{
		nWaterServer * S = this->ref_Server.get();
		nChannelContext* chnContext = sceneGraph->GetChannelContext();
		n_assert(chnContext);
		float curr = chnContext->GetChannel1f(this->localChannelIndex);
		tpassed= curr;
		S->Update(curr);
	}
//n_printf("type check\n");	
	//check for type switch
	if(this->m_Nt != this->m_Type)
	{
		if(this->ref_Server.isvalid())
		{
			nWaterServer * S = this->ref_Server.get();
			S->RemWaterRef(this->m_Type);
			S->AddWaterRef(this->m_Nt);
			this->m_Type = this->m_Nt;
			if (this->ref_vb.isvalid()) 
			{
				this->ref_vb->Release();
				this->ref_vb.invalidate();
			}
		}
	}	

	if(!this->ref_ibuf.isvalid())
	{
		render = initIndex();//ref_ib
	}
	
	if(!this->ref_vb.isvalid())
	{
		render &= initBuffer();
	}

	sceneGraph->SetVertexBuffer(0);

	if(render)
	{
		this->ref_vb.get()->Render(
			this->ref_ibuf.get(), 
			sceneGraph->GetPixelShader(),
			sceneGraph->GetTextureArray());
	//	if (this->castShadows && this->refShadowCaster.isvalid())
	//	{
	//		sceneGraph->SetShadowCaster(this->refShadowCaster.get());
	//	}
	}


//n_printf("now the tree\n");	
	// clear scene graph vertex buffer after child nodes wrote to it
	//sceneGraph->SetVertexBuffer(0);
//n_printf("root %d\n",&(this->m_Qt.m_root));
//	matrix44 trans = sceneGraph->GetTransform();
/*	if(!(this->m_Qt.m_root))
	{
//n_printf("subdivide\n");
		//init tree
		this->m_Qt.m_root = n_new Quad2D(0,0,this->m_XSize/2);
		this->m_Qt.m_root->m_Level = this->m_XSize;
		this->m_Qt.subdivide(this->m_Qt.m_root, this->m_XSize);
		this->m_Qt.m_root = n_new Quad2D(0,0,4096);
		this->m_Qt.m_root->m_Level = 2048;
		this->m_Qt.subdivide(this->m_Qt.m_root, 4096);
	}
*/
//n_printf("%d\n",pass);
/*		pass++;
		if(pass >= 50)
		{
//n_printf("%d ",rendered);
//n_printf(" %f %f\n",this->m_Qt.m_pos.x, this->m_Qt.m_pos.y);
			step = step /2;
			if(step < 2)
			{

				step = 256;
			}
			pass = 0;
		}
		rendered =0;
//	this->m_Qt.initClip((nGfxServer *)this->refGfx.get());
//	if(tpassed < 10.0f)
//	this->m_Qt.tagVisible(this->m_Qt.m_root,PARTIALLY_INSIDE_FRUSTUM,this->m_XSize);
//	this->m_Qt.renderDebug((nGfxServer *)this->refGfx.get(),this->m_Qt.m_root);
*/
//n_assert(false);

}

/// create the ref_ib (reference index buffer)
bool nWaterNode::initIndex(void)
{
    n_assert(!this->ref_ibuf.isvalid());
	char iname[256];
	if(this->m_Type<3)
		sprintf(iname,"nWaterNode_%d", SampleSize);
	else
		sprintf(iname,"nWaterNode_3to1_%d", SampleSize);
	//find index
	this->ref_ibuf = this->refGfx->FindIndexBuffer(iname);
    if(this->ref_ibuf.isvalid())
	{
        ((nIndexBuffer *)(this->ref_ibuf.get()))->AddRef();
//n_printf("initindex found\n");
		return true;
	}
	else
	{
		//it is not the task of the waternode to create the buffers.
//n_printf("initindex not found\n");
		return false;
	}
}

bool nWaterNode::initBuffer()
{
    n_assert(!this->ref_vb.isvalid());
	char iname[256];
	sprintf(iname,"nWaterNode_%d_%d",this->m_Type,SampleSize);
	
	this->ref_vb = this->refGfx->FindVertexBuffer(iname);
    if(this->ref_vb.isvalid())
	{
        ((nVertexBuffer *)(this->ref_vb.get()))->AddRef();
		return true;
	}
	else
	{
		//it is not the task of the waternode to create the buffers.
		return false;
	}
}

