#define N_IMPLEMENTS nWaterServer
//------------------------------------------------------------------------------
//  (C) 2002	tom@3d-inferno.com
//------------------------------------------------------------------------------
#include "water/nwaterserver.h"
#include "kernel/nfileserver.h"


static void n_getrefs(void* slf, nCmd* cmd);
static void n_setfps(void* slf, nCmd* cmd);
static void n_getfps(void* slf, nCmd* cmd);
static void n_setchopp(void* slf, nCmd* cmd);
static void n_getchopp(void* slf, nCmd* cmd);

//------------------------------------------------------------------------------
/**
    @scriptclass
    nwater
    
    @superclass
    nanimnode

    @classinfo
    A detailed description of what the class does (written for script programmers!) 
*/
void
n_initcmds(nClass* clazz)
{
    clazz->BeginCmds();
    clazz->AddCmd("v_setfps_i", 'SFPS', n_setfps);
	clazz->AddCmd("i_getfps_v", 'GFPS', n_getfps);
	clazz->AddCmd("i_getrefs_v", 'GERF', n_getrefs);
    clazz->AddCmd("f_getchopp_v", 'GCHP', n_getchopp);
	clazz->AddCmd("v_setchopp_f", 'SCHP', n_setchopp);
	clazz->EndCmds();
}

//------------------------------------------------------------------------------
/**
    @cmd
    xxx

    @input
    v

    @output
    v

    @info
    detailed description (for script programmers! no C++ babble)
*/

static
void
n_getrefs(void* slf, nCmd* cmd)
{
    nWaterServer* self = (nWaterServer*) slf;
    cmd->Out()->SetI(self->GetRefs());
}

static
void
n_setfps(void* slf, nCmd* cmd)
{
    nWaterServer* self = (nWaterServer*) slf;
    self->SetFPS(cmd->In()->GetI());
}

static
void
n_getchopp(void* slf, nCmd* cmd)
{
    nWaterServer* self = (nWaterServer*) slf;
	cmd->Out()->SetF(self->GetChopp());
}

static
void
n_setchopp(void* slf, nCmd* cmd)
{
    nWaterServer* self = (nWaterServer*) slf;
    self->SetChopp(cmd->In()->GetF());
}
//------------------------------------------------------------------------------
/**
    @cmd
    xxx

    @input
    v

    @output
    v

    @info
    detailed description (for script programmers! no C++ babble)
*/
static void n_getfps(void* slf, nCmd* cmd)
{
    nWaterServer* self = (nWaterServer*) slf;
    cmd->Out()->SetI(self->GetFPS());
}
/* savecmds

		//--- setfps ---
		if (this->GetFPS())
		{
			cmd = fs->GetCmd(this, 'SFPS');
			cmd->In()->SetI(this->GetFPS());
			fs->PutCmd(cmd);
		}
*/